#include "selection.h"
#include "macros.h"

void selnormalize() {
    int i;

    if (sel.type == SEL_REGULAR && sel.ob.y != sel.oe.y) {
        sel.nb.x = sel.ob.y < sel.oe.y ? sel.ob.x : sel.oe.x;
        sel.ne.x = sel.ob.y < sel.oe.y ? sel.oe.x : sel.ob.x;

    } else {
        sel.nb.x = MIN(sel.ob.x, sel.oe.x);
        sel.ne.x = MAX(sel.ob.x, sel.oe.x);
    }

    sel.nb.y = MIN(sel.ob.y, sel.oe.y);
    sel.ne.y = MAX(sel.ob.y, sel.oe.y);

    selsnap(&sel.nb.x, &sel.nb.y, -1);
    selsnap(&sel.ne.x, &sel.ne.y, +1);

    /* expand selection over line breaks */
    if (sel.type == SEL_RECTANGULAR)
        return;

    i = tlinelen(sel.nb.y);
    if (i < sel.nb.x)
        sel.nb.x = i;

    if (tlinelen(sel.ne.y) <= sel.ne.x)
        sel.ne.x = term.col - 1;
}

void selscroll(int orig, int n) {
    if (sel.ob.x == -1)
        return;

    if (BETWEEN(sel.nb.y, orig, term.bot) !=
        BETWEEN(sel.ne.y, orig, term.bot)) {
        selclear();

    } else if (BETWEEN(sel.nb.y, orig, term.bot)) {
        sel.ob.y += n;
        sel.oe.y += n;

        if (sel.ob.y < term.top || sel.ob.y > term.bot ||
            sel.oe.y < term.top || sel.oe.y > term.bot) {
            selclear();

        } else {
            selnormalize();
        }
    }
}

void selclear(void) {
    if (sel.ob.x == -1)
        return;
    sel.mode = SEL_IDLE;
    sel.ob.x = -1;
    tsetdirt(sel.nb.y, sel.ne.y);
}

void selinit(void) {
    sel.mode = SEL_IDLE;
    sel.snap = 0;
    sel.ob.x = -1;
}
